<?php

// Digital Shop version 3.0.4
// Copyright (C) 2008-2014 JF Nutbroek <jfnutbroek@gmail.com>
// See the included End User License Agreement (EULA)

require_once('inc/configuration.php');
require_once('inc/css.php');
require_once('inc/languages.php');

// Problems will be written to file
$logtofile=false;

// Start without errors
$ipn_error='';
$log=false;

// Autohorize.net does not provide fee info 
$fee=0;

// Check if amount from Authorize.net is correct
$check_amount=0;

// Retrieve all postback information for debugging
$req='';
foreach ($_REQUEST as $key => $value) {
	$value=urlencode(stripslashes($value));
	$req.="&$key=$value";
}

// Verify some required variables
if (isset($_REQUEST['x_email'])) {$payer_email=$_REQUEST['x_email'];} else {$log=true;$ipn_error.="No receiver email specified\n\n";}
$receiver_email=$an_business; // Handled by Authorize.net
if (isset($_REQUEST['x_amount'])) {$amount=$_REQUEST['x_amount'];} else {$amount=0;$log=true;$ipn_error.="No total amount specified\n\n";}
if (isset($_REQUEST['x_MD5_Hash'])) {$md5sig=$_REQUEST['x_MD5_Hash'];} else {$md5sig='';$log=true;$ipn_error.="No md5 hash specified\n\n";}
if (isset($_REQUEST["x_item_number"])) {$ordercode=$_REQUEST["x_item_number"];} else {$log=true;$ipn_error.="No item_number specified\n\n";}				
$mc_currency='USD'; // Only USD is accepted
if (isset($_REQUEST['x_invoice_num'])) {$txn_id=$_REQUEST['x_invoice_num'];} else {$txn_id='';$log=true;$ipn_error.="No transaction id specified\n\n";}
if (isset($_REQUEST['x_response_code'])) {$payment_status=$_REQUEST['x_response_code'];} else {$payment_status='Unknown';$log=true;$ipn_error.="No payment status specified\n\n";}

// CHECK 0 : Check if the buyer was redirected from Authorize.net and secret signature is correct
$sig_string='md5';
$sig_string=strtoupper(md5($an_md5 . $an_loginid . $_REQUEST['x_trans_id'] . $amount));
	
if($sig_string!=$md5sig) {$log=true;$ipn_error.="MD5 signature is not correct $sig_string (local) versus $md5sig (remote)\n\n";}

// Proceed with security checks and checkout procedure
if (!$log) {

	// Retrieve cart contents 
	$ids=array();
	if ($ordercode!='') {
		if (substr($ordercode,0,2)=='DS') {
			$ordercode=ltrim($ordercode,'DS');
			$ids=explode("-", $ordercode);
		} else {
			exit;  // Ordercode not intended for Digital Shop
		}
	}

	// Calculate taxes
	$tax=0;
	
	// Determine country for invoicing
	if (isset($_REQUEST['x_country_iso'])) {
		$country=$_REQUEST['x_country_iso'];
	} else {
		$country='--';
	}
	if (array_key_exists($country,$countries)) {$countryinvoice=$countries[$country];} else {$countryinvoice='';}
	
	// Connect to database
	$conn=mysql_connect($host,$user,$password) or die ('Error connecting to mysql');
	if ($database=='') {mysql_select_db('digitalshop');} else {mysql_select_db($database);}

	// Check for coupon and affiliate ID
	$unset=array();
	$coupon='';
	$aid='';
	$aid_emailpay='';
	$aid_bank='';
	$couponvalue=0;
	$couponcntr=0;
	foreach($ids as $key => $id) {
		if (substr($id,0,1)=='C' && $check_amount==0) {
			// Check for valid coupon
			$testid=mysql_real_escape_string($id);
			$query="SELECT * FROM digitalshopcoupon WHERE coupon = '$testid'";
			$resultcoupon=mysql_query($query);
			if ($resultcoupon && mysql_num_rows($resultcoupon)) {
				$row=mysql_fetch_array($resultcoupon);
				$id=$row[coupon];
				if ($row[expire]>time() && $row[cntr]<$row[maxcntr]) {
					// Valid coupon
					$check_amount=floatval($row[value]);
					$unset[]=$id;
					$coupon=$id;
					$couponvalue=$row[value];
					$couponcntr=$row[cntr]+1;
				} else {
					$log=true;
					$ipn_error.="Coupon expired or used. Refund might be required.\n\n";			
				}
			} else {
				$log=true;
				$ipn_error.="Coupon does not exist. Refund might be required.\n\n";		
			}
		} else if (substr($id,0,1)=='C') {
			// Only 1 coupon per order
			$unset[]=$id;
		}
		if ($affiliate && substr($id,0,1)=='A' && $aid=='') {
			// Check for valid affiliate
			$testaid=mysql_real_escape_string(ltrim($id,'A'));
			$query="SELECT aid, emailpay, bank FROM digitalshopaffiliate WHERE aid = '$testaid'";
			$resultaid=mysql_query($query);
			if ($resultaid && mysql_num_rows($resultaid)) {
				$row=mysql_fetch_array($resultaid);
				$aid=$row[aid];
				$aid_emailpay=$row[emailpay];
				$aid_bank=$row[bank];
				$unset[]=$id;
			} else {
				// Affiliate is unknown - no need to cancel order
				$unset[]=$id;		
			}
		} else if (substr($id,0,1)=='A') {
			// Only 1 affiliate per order
			$unset[]=$id;
		}	
	}
	foreach($unset as $id) {
		$key=array_search($id,$ids);
		unset($ids[$key]);
	}
	$ids=array_values($ids);

	// CHECK1: verify the receiver of the funds	
	if ($receiver_email==$an_business && !$log) {									// CHECK2: Verify the receiver of the funds
		if ($payment_status==1) {										// CHECK3: Check status of payment
			$query="SELECT * FROM digitalshopkey WHERE txnid = '$txn_id'";					// CHECK4: Verify txn_id does not exist
			$result=mysql_query($query);
			if ($result && !mysql_num_rows($result)) {								
				$names=array();$prices=array();
				foreach($ids as $id) {									// CHECK5: Verify if payment amount is correct
					if (strlen($id)>4) {$multiplier=(strlen($id)-3)/2;$id=intval(substr($id,0,3));} else {$multiplier=1;}
					$query="SELECT name, price, disc FROM digitalshop WHERE id = '$id'";
					$result=mysql_query($query);
					if ($result && mysql_num_rows($result)) {
						$row=mysql_fetch_array($result);
						if ($multiplier!=1) {$quantity="($multiplier)";} else {$quantity='';}
						$names[]="$row[name] $quantity";
						if (floatval($row[disc])>0) {
						        $row[price]=floatval(str_replace(',','',$row[price]))-(floatval(str_replace(',','',$row[price]))*(floatval($row[disc])/100));
						}
						$row[price]=number_format(floatval($row[price]),2,'.',',');
						$prices[]=number_format(floatval(str_replace(',','',$row[price]))*$multiplier,2,'.',',');
						$check_amount=$check_amount+(floatval(str_replace(',','',$row[price]))*$multiplier);
						if (floatval(str_replace(',','',$row[price]))==0) {$currency='FAIL';}	// CHECK6: You cannot order disabled items - fail next check
					}
				}
				if (($check_amount-$amount)<=0.01 && $amount>$paywyw_minimum && substr($mc_currency,0,strlen($currency))==$currency) {	// Check 7: Make sure amount and currency is correct (higher amounts are accepted - taxes)
					// New VALID transaction!
					$keys=array();
					foreach($ids as $key => $id) {
						$keys[]=createkey($id,$payer_email,$txn_id,$country,$prices[$key]);
					}
					if (!digitalshopmailkey($payer_email,$mailfrom,$mailbcc,$keys,$names,$txn_id)) {
						$log=true;
						$ipn_error="Unable to send email with key to buyer $payer_email";
					} else {
						if (array_key_exists($country,$add_taxes)) {$tax=$amount-($amount/(1+($add_taxes[$country]/100)));} 
						if ($sendinvoice) {
							if (!digitalshopmailinvoice($payer_email,$mailfrom,$mailbcc,$keys,$names,$txn_id,$prices,$amount,$countryinvoice,$tax,$coupon,$couponvalue)) {
								$log=true;
								$ipn_error="Unable to send email with invoice to buyer $payer_email";							
							}
						}
						if ($coupon!='') {
							// Increase coupon counter
							$query="UPDATE digitalshopcoupon SET cntr = '$couponcntr' WHERE coupon = '$coupon'";
							$result=mysql_query($query);
						}
						if ($aid!='') {
							// Affiliate commission
							$netorder=$amount-$tax-$fee;
							$deduct=$netorder*($reduction/100);
							$payaid=number_format(floatval(($netorder-$deduct)*($commission/100)),3,'.',',');			
							$timestamp=time();
							$query="INSERT INTO digitalshopcommission (aid, stamp, txnid, credit, debet) VALUES ('$aid', '$timestamp', '$txn_id', '$payaid', '0')";
							$result=mysql_query($query);
							//Check Affiliate balance
							$credit=0;
							$debet=0;
							$query="SELECT SUM(credit + 0) as spaid FROM digitalshopcommission WHERE aid = '$aid'";
							$result=mysql_query($query);
							if ($result && mysql_num_rows($result)) {
								$row=mysql_fetch_array($result);
								$credit=$row[spaid];
							}
							$query="SELECT SUM(debet + 0) as spaid FROM digitalshopcommission WHERE aid = '$aid'";
							$result=mysql_query($query);
							if ($result && mysql_num_rows($result)) {
								$row=mysql_fetch_array($result);
								$debet=$row[spaid];
							}
							if (($credit-$debet)>$commission) {
								// Affiliate needs to receive payment warn administrator
								digitalshopmailcommission($an_business,$mailfrom,'',$aid,$credit,$debet,$aid_emailpay,$aid_bank);
							}
						}
						if ($permanent_commission) {
							// Pay Permanent affiliate commission
							$netorder=$amount-$tax-$fee;
							$deduct=$netorder*($reduction/100);
							$payaid=number_format(floatval(($netorder-$deduct)*($commission/100)),3,'.',',');			
							$timestamp=time();
							$query="INSERT INTO digitalshopcommission (aid, stamp, txnid, credit, debet) VALUES ('$permanent_affiliate', '$timestamp', '$txn_id', '$payaid', '0')";
							$result=mysql_query($query);
							//Check Affiliate balance
							$credit=0;
							$debet=0;
							$query="SELECT SUM(credit + 0) as spaid FROM digitalshopcommission WHERE aid = '$permanent_affiliate'";
							$result=mysql_query($query);
							if ($result && mysql_num_rows($result)) {
								$row=mysql_fetch_array($result);
								$credit=$row[spaid];
							}
							$query="SELECT SUM(debet + 0) as spaid FROM digitalshopcommission WHERE aid = '$permanent_affiliate'";
							$result=mysql_query($query);
							if ($result && mysql_num_rows($result)) {
								$row=mysql_fetch_array($result);
								$debet=$row[spaid];
							}
							if (($credit-$debet)>$commission) {
								// Affiliate needs to receive payment warn administrator
								$query="SELECT aid, emailpay, bank FROM digitalshopaffiliate WHERE aid = '$permanent_affiliate'";
								$resultaid=mysql_query($query);
								if ($resultaid && mysql_num_rows($resultaid)) {
									$row=mysql_fetch_array($resultaid);
									$aid_emailpay=$row[emailpay];
									$aid_bank=$row[bank];
									digitalshopmailcommission($pp_business,$mailfrom,'',$permanent_affiliate,$credit,$debet,$aid_emailpay,$aid_bank);
								}
							}
						}						
						// Transaction OK - send reply to Autohorize.net
						if (!$iframe)
							header("Location: $shopurl/thankyou.php");
						else
							header("Location: $thankyou_webpage");
					}
				} else {
					$log=true;
					$ipn_error='Total amount or currency is incorrect';
				}
			} else {
				$log=true;
				$ipn_error='Transaction ID already exists. Order already processed?';			
			}
		} else {
			$log=true;
			$ipn_error='Payment status is not completed';
		}
	} else {
		if ($receiver_email!=$an_business) {$log=true;$ipn_error='Wrong business email';}
	}
}

// Log errors to email
if ($log) {
	
	// Errormessage
	$mailbody="Authorize.net feedback processing order from $shopname. \n\n" . "Post string:\n\n" . $req . "\n\n";
	$mailbody.="Payment status: " . "$payment_status\n";
	$mailbody.="Transaction ID: $txn_id\n";
	if ($amount<$check_amount && $check_amount!=0)
		$mailbody.="Payment gross: $amount / Payment should be (excl. tax): $check_amount\n";
	if ($ipn_error!='')
	$mailbody.="Additional info: " . "$ipn_error\n\n";	
	$mailbody.="Debugging info: " . "$result\n";
	
	// Log to file
	if ($logtofile) {
		if ($fp=fopen('errorlog','a')) {
			fwrite($fp,"$shopname Payment Status " . date('Y-m-d H:i') . " : " . $payment_status . "\n\n" . $mailbody);
			fclose($fp);		
		}
	}
	// Log to email	
	if ($sandbox) {$an_business=$mailfrom;}
	$headers="From: $an_business\r\n";
	if ($receive_ipn_error)
		mail($an_business,"$shopname Payment Problem " .$txn_id,$mailbody,$headers);
		
}

function createkey($fileid,$email,$txn_id,$country,$price) {
	
	global $fee,$couponvalue,$amount,$tax;
	$digid=randomkey();
	$sold=time();
	$price=str_replace(',','',$price);
	$fee_item=number_format((floatval($price)/($amount-$tax-floatval($couponvalue)))*$fee,3,'.',',');
	$price_item=floatval($price)+(floatval($price)/($amount-$tax-floatval($couponvalue)))*floatval($couponvalue)+(floatval($price)/($amount-$tax-floatval($couponvalue)))*floatval($tax);
	$price_item=number_format(floatval($price_item),3,'.',',');
	$query="SELECT * FROM digitalshopkey WHERE digid = '$digid'";
	$result=mysql_query($query);
	while ($result && mysql_num_rows($result)) {
		$digid=randomkey();
		$query="SELECT * FROM digitalshopkey WHERE digid = '$digid'";
		$result=mysql_query($query);
	}
	// Store new unique key
	$query="INSERT INTO digitalshopkey (digid, email, fileid, expire, cntr, txnid, sold, country, gross, fee) VALUES ('$digid', '$email', '$fileid', '0', '0', '$txn_id', '$sold', '$country', '$price_item', '$fee_item')";
	mysql_query($query) or die('Error, mysql key storage failed');	
	return $digid;

}

function randomkey() {
	
	$key='';
	$chars=array('1','2','3','4','5','6','7','8','9','0','a','b','c','d','e','f','g','h','i','j','k','l','m','n',
		'1','2','3','4','5','6','7','8','9','0','o','p','q','r','s','t','u','v','w','x','y','z',
		'1','2','3','4','5','6','7','8','9','0','A','B','C','D','E','F','G','H','I','J','K','L','M','N',
		'1','2','3','4','5','6','7','8','9','0','O','P','Q','R','S','T','U','V','W','X','Y','Z');
	$rand_keys=array_rand($chars,15);
	for ($c=0;$c<15;$c++) {
		if ($c==5) {$key=$key.'-';}
		if ($c==10) {$key=$key.'-';}
		$key=$key.$chars[$rand_keys[$c]];
	}
	return $key;

}

function digitalshopmailkey($mailto,$mailfrom,$mailbcc,$keys,$names,$txn_id) {
	
	global $lang_45,$lang_46,$lang_47,$lang_48,$lang_49,$lang_50,$shopname,$email_rewrite,$shopcolor,$pagecolor,$textcolor,$shopurl,$show_header,$headeremailimage,$iframe,$download_webpage;
	if ($email_rewrite) {
		$mailto=substr($mailto,0,strpos($mailto,'@')) . " <". $mailto . ">";
		$mailfrom=substr($mailfrom,0,strpos($mailfrom,'@')) . " <$mailfrom>";
		if ($mailbcc!='') {$mailbcc=substr($mailbcc,0,strpos($mailbcc,'@')) . " <$mailbcc>";}
	}
	if (!$iframe) {
		$link=$shopurl . '/download.php';
	} else {
		$link=$download_webpage;
		$shopcolor='#FAFAFA';
	}
	$linkimage=$shopurl . '/shopgfx';
	$headers="From: $mailfrom\r\n";
	$headers.="Reply-to: $mailfrom\r\n";
	if ($mailbcc!='') {$headers.="BCC: $mailbcc\r\n";}
	$bound_text=md5(uniqid(time()));
	$headers.="MIME-Version: 1.0\r\n" . "Content-Type: multipart/alternative; boundary=\"$bound_text\"\r\n";
	$message="--$bound_text\r\n"
		."Content-Type: text/plain; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."$lang_45 $txn_id\r\n"
		."$lang_46 \r\n"
		."$lang_47 $link\r\n";
		foreach($keys as $index => $key) {$message.="$lang_48 $key (". $names[$index] .")\r\n";}
		$message.="$lang_49 \r\n"
		."$shopname \r\n\r\n"
		."--$bound_text\r\n"	
		."Content-Type: text/html; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."<html><head><title></title></head><body><center>"
		."<table  border=\"0\" width=\"630\" cellpadding=\"0\" cellspacing=\"0\" style=\"max-width:630px; margin: 0 auto;\"><tr><td>"
                ."<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lt.gif\" >&nbsp;</td><td height=\"39px\" background=\"$linkimage/tabletop.gif\" >&nbsp;</td>"
                ."<td width=\"39px\" height=\"39px\" background=\"$linkimage/rt.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" background=\"$linkimage/tableleft.gif\" >&nbsp;</td><td style=\"background-color : $shopcolor\">";
        if ($show_header)
                $message.="<table width=\"100%\"><tr><td style=\"text-align : center;width : 100%;\"><img src=\"$linkimage/$headeremailimage\" style=\"padding-bottom : 20px;border : 0px;\" /></td></tr></table>";
         $message.="<table>"
                ."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_45 $txn_id </td></tr><tr><td>&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_46 </td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_47 <a href=\"$link\">$link</a></td></tr><tr><td>&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_48</td></tr><tr><td>&nbsp;</td></tr>";
	foreach ($keys as $index => $key) {
                $message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\"><span style=\"font-weight : bold;\"><a href=\"${link}?downloadcode=$key\">$key</a></span><br />". $names[$index] ."</td></tr><tr><td>&nbsp;</td></tr>";
        }
	$message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_49</td></tr>"
                ."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold;\">$shopname</td></tr><tr><td>&nbsp;</td></tr>"
		."</table>"
                ."</td><td width=\"39px\" background=\"$linkimage/tableright.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lb.gif\" >&nbsp;</td>"
                ."<td height=\"39px\" background=\"$linkimage/tablebottom.gif\" >&nbsp;</td><td width=\"39px\" height=\"39px\" background=\"$linkimage/rb.gif\" >&nbsp;</td></tr></table>"        
                ."</td></tr></table></center></body></html>\r\n\r\n"							
		."--$bound_text--\r\n\r\n";
	return mail($mailto,"$lang_50 $shopname",wordwrap($message,70),$headers);

}

function digitalshopmailinvoice($mailto,$mailfrom,$mailbcc,$keys,$names,$txn_id,$prices,$amount,$country,$tax,$coupon,$couponvalue) {
	
	global $lang_45,$lang_46,$lang_47,$lang_48,$lang_49,$lang_50,$shopname,$email_rewrite,$shopcolor,$pagecolor,$textcolor,$shopurl,$show_header;
	global $currency,$an_business,$location,$lang_01,$lang_03,$lang_34,$lang_83,$lang_84,$lang_85,$lang_87,$headeremailimage,$iframe,$lang_160;
	$originaladdress=$mailto;
	if ($email_rewrite) {
		$mailto=substr($mailto,0,strpos($mailto,'@')) . " <". $mailto . ">";
		$mailfrom=substr($mailfrom,0,strpos($mailfrom,'@')) . " <$mailfrom>";
		if ($mailbcc!='') {$mailbcc=substr($mailbcc,0,strpos($mailbcc,'@')) . " <$mailbcc>";}
	}
	$linkimage=$shopurl . '/shopgfx';
	if ($iframe)
		$shopcolor='#FAFAFA';	
	$headers="From: $mailfrom\r\n";
	$headers.="Reply-to: $mailfrom\r\n";
	if ($mailbcc!='') {$headers.="BCC: $mailbcc\r\n";}
	$bound_text=md5(uniqid(time()));
	if ($tax>0) {
		$lang_84=str_replace('[tax]','',$lang_84);
	}	
	$headers.="MIME-Version: 1.0\r\n" . "Content-Type: multipart/alternative; boundary=\"$bound_text\"\r\n";
	$message="--$bound_text\r\n"
		."Content-Type: text/plain; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."$lang_83 $txn_id \r\n"
		."$originaladdress \r\n"
		."$country \r\n"
		."$lang_01 $lang_03 $currency \r\n";
		// Find PWYW products
		$unset=array();
		$sum=0;$description="$lang_160: ";
		foreach($keys as $key => $id) {
			if (floatval($prices[$key])==0.01) {
				$unset[]=$key;
				$description.="$names[$key], ";
			} else {
				$sum+=floatval($prices[$key]);
			}
		}
		$sum+=floatval($couponvalue);
		$description=rtrim($description, ', ');
		$pwyw=number_format(floatval($amount-$tax-$sum),2,'.',',');
		if(count($unset)==1) {
			$prices[$unset[0]]=$pwyw;
		} else if (count($unset)>1) {
			foreach($unset as $key) {
				unset($keys[$key]);
				unset($prices[$key]);
				unset($names[$key]);
			}
			$keys=array_values($keys);
			$prices=array_values($prices);
			$names=array_values($names);
			$keys[]='x';
			$prices[]=$pwyw;
			$names[]=$description;
		}		
		foreach($keys as $index => $key) {$message.="$names[$index] $prices[$index] \r\n";}
		if ($coupon!='' || $tax>0) {
			$message.="+ ___________ \r\n";
		}
		if ($coupon!='') {
			$message.="$lang_87 $coupon $couponvalue \r\n";
		}		
		if ($tax>0) {
			$message.="$lang_84 $currency ". number_format(floatval($tax),2,'.',',') ." \r\n";
		}		
		$message.="+ ___________ \r\n";
		$message.="$lang_34 $currency ". number_format(floatval($amount),2,'.',',') ." \r\n"
		."$an_business \r\n"
		."$location \r\n"
		."$lang_49 \r\n"
		."$shopname \r\n\r\n"
		."--$bound_text\r\n"	
		."Content-Type: text/html; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."<html><head><title></title></head><body><center>"
		."<table  border=\"0\" width=\"630\" cellpadding=\"0\" cellspacing=\"0\" style=\"max-width:630px; margin: 0 auto;\"><tr><td>"
                ."<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lt.gif\" >&nbsp;</td><td height=\"39px\" background=\"$linkimage/tabletop.gif\" >&nbsp;</td>"
                ."<td width=\"39px\" height=\"39px\" background=\"$linkimage/rt.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" background=\"$linkimage/tableleft.gif\" >&nbsp;</td><td style=\"background-color : $shopcolor\">";
        if ($show_header)
                $message.="<table width=\"100%\"><tr><td style=\"text-align : center;width : 100%;\"><img src=\"$linkimage/$headeremailimage\" style=\"padding-bottom : 20px;border : 0px;\" /></td></tr></table>";
         $message.="<table width=\"100%\">"
                ."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;font-weight : bold;padding-right : 20px;\" nowrap=\"nowrap\">$lang_83 $txn_id</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$originaladdress</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$country</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold;\" nowrap=\"nowrap\">$lang_01</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;font-weight : bold;padding-right : 20px;\" nowrap=\"nowrap\">$lang_03 $currency</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>";
	foreach ($keys as $index => $key) {
                $message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" >". $names[$index] ."</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">". $prices[$index] ."</td></tr>";
        }
	if ($coupon!='' || $tax>0) {
		$message.="<tr><td>&nbsp; </td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">+ ___________</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>";
	}
	if ($coupon!='') {
                $message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$lang_87 $coupon</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">". $couponvalue ."</td></tr>";
	}
	if ($tax>0) {
		$message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$lang_84</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">". number_format(floatval($tax),2,'.',',') ."</td></tr>";
	}	
	$message.="<tr><td>&nbsp; </td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">+ ___________</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>";		
		$message.="<tr><td>&nbsp;</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;font-weight : bold;padding-right : 20px;\" nowrap=\"nowrap\">$lang_34 $currency ". number_format(floatval($amount),2,'.',',') . "</td></tr>"
		."<tr><td colspan=\"2\" >&nbsp;</td></tr><tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$an_business</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$location</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$lang_49</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold;\" nowrap=\"nowrap\">$shopname</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>"
                ."</table>"
                ."</td><td width=\"39px\" background=\"$linkimage/tableright.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lb.gif\" >&nbsp;</td>"
                ."<td height=\"39px\" background=\"$linkimage/tablebottom.gif\" >&nbsp;</td><td width=\"39px\" height=\"39px\" background=\"$linkimage/rb.gif\" >&nbsp;</td></tr></table>"        
                ."</td></tr></table></center></body></html>\r\n\r\n"							
		."--$bound_text--\r\n\r\n";
	return mail($mailto,"$lang_85 $shopname",wordwrap($message,70),$headers);

}

function digitalshopmailcommission($mailto,$mailfrom,$mailbcc,$aid,$credit,$debet,$aid_emailpay,$aid_bank) {
	
	global $currency,$commission,$shopname,$email_rewrite,$shopcolor,$pagecolor,$textcolor,$shopurl,$show_header,$headeremailimage,$iframe;
	if ($email_rewrite) {
		$mailto=substr($mailto,0,strpos($mailto,'@')) . " <". $mailto . ">";
		$mailfrom=substr($mailfrom,0,strpos($mailfrom,'@')) . " <$mailfrom>";
		if ($mailbcc!='') {$mailbcc=substr($mailbcc,0,strpos($mailbcc,'@')) . " <$mailbcc>";}
	}
	$linkimage=$shopurl . '/shopgfx';
	if ($iframe)
		$shopcolor='#FAFAFA';	
	$headers="From: $mailfrom\r\n";
	$headers.="Reply-to: $mailfrom\r\n";
	if ($mailbcc!='') {$headers.="BCC: $mailbcc\r\n";}
	$bound_text=md5(uniqid(time()));
	$headers.="MIME-Version: 1.0\r\n" . "Content-Type: multipart/alternative; boundary=\"$bound_text\"\r\n";
	$message="--$bound_text\r\n"
		."Content-Type: text/plain; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."Dear $shopname Administrator,\r\n"
		."Affiliate with ID A$aid has reached the commission threshold.\r\n"
		."Current balance is " . number_format(floatval($credit-$debet),2,'.',',')  ." $currency.\r\n"
		."Please proceed with payment of " . number_format(floatval($commission),2,'.',',')  ." $currency to PayPal account: $aid_emailpay\r\n"
		."and register this affiliate payment in Digital Shop accordingly.\r\n"
		."$shopname \r\n\r\n"
		."--$bound_text\r\n"	
		."Content-Type: text/html; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."<html><head><title></title></head><body><center>"
		."<table  border=\"0\" width=\"630\" cellpadding=\"0\" cellspacing=\"0\" style=\"max-width:630px; margin: 0 auto;\"><tr><td>"
                ."<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lt.gif\" >&nbsp;</td><td height=\"39px\" background=\"$linkimage/tabletop.gif\" >&nbsp;</td>"
                ."<td width=\"39px\" height=\"39px\" background=\"$linkimage/rt.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" background=\"$linkimage/tableleft.gif\" >&nbsp;</td><td style=\"background-color : $shopcolor\">";
        if ($show_header)
                $message.="<table width=\"100%\"><tr><td style=\"text-align : center;width : 100%;\"><img src=\"$linkimage/$headeremailimage\" style=\"padding-bottom : 20px;border : 0px;\" /></td></tr></table>";
         $message.="<table>"
                ."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold\">Dear $shopname Administrator,</td></tr><tr><td>&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">Affiliate with ID <b>A$aid</b> has reached the commission threshold.</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">Current balance is <b>" . number_format(floatval($credit-$debet),2,'.',',')  ."</b> $currency.</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">Please pay <b>" . number_format(floatval(floor(($credit-$debet)/$commission)*$commission),2,'.',',')  ." $currency</b> to $aid_bank account: $aid_emailpay </td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">and register this affiliate payment in Digital Shop accordingly.</td></tr><tr><td>&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold;\">$shopname</td></tr><tr><td>&nbsp;</td></tr>"
                ."</table>"
                ."</td><td width=\"39px\" background=\"$linkimage/tableright.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lb.gif\" >&nbsp;</td>"
                ."<td height=\"39px\" background=\"$linkimage/tablebottom.gif\" >&nbsp;</td><td width=\"39px\" height=\"39px\" background=\"$linkimage/rb.gif\" >&nbsp;</td></tr></table>"        
                ."</td></tr></table></center></body></html>\r\n\r\n"							
		."--$bound_text--\r\n\r\n";
	return mail($mailto,"Commission due for affiliate A$aid",wordwrap($message,70),$headers);

}

?>
